(: Funzione che prende in input un file e riordina i figli di una lista in base 
al valore dell'ordinamento
 
Author : Leonardo Puleggi  
Email : leonardo.puleggi@fastwebnet.it
Version : 0.1
:)


declare variable $instance as xs:string external;
declare variable $nome_ord as xs:string external;

(: Funzione che realizza la ricorsione. Dato un nodo verifica se qualcuno dei figli
 una lista; se lo  riordina quel nodo:)

declare function local:faiOrder($input) {
let $figli := $input/child::node()
for $elemento in $figli
return if(compare(name($elemento),$nome_ord)=0) then
	(element {name($elemento)} {local:riordina($elemento)})
	else if(exists($elemento/*)) then	
	element {name($elemento)}
	{local:faiOrder($elemento)}
	else $elemento
};

(: Funzione che riordina struttando l'order by e cancella l'elemento b-order :)

declare function local:riordina($input){
	for $k in $input/*
	order by $k/data(*[name()=concat($nome_ord,"-order")])
	return element{name($k)} 
	{for $attributo in $k/@* return $attributo,
	for $figlio in $k/* return if (compare(name($figlio),concat($nome_ord,"-order"))!=0)
	then $figlio
	else ()}
};

(: Funzione Main:)

let $inutile:=1
return local:faiOrder(doc($instance))