(: Funzione che unisce gli elementi con lo stesso nome figlio del nodo passato come parametro

Author : Leonardo Puleggi  
Email :leonardo.puleggi@fastwebnet.it
Version : 0.1
:)

declare variable $instance as xs:string external;
declare variable $name as xs:string external;

declare function local:ordina($lista){
	for $i in $lista
	order by name($i)
	return $i
};


declare function local:trova($lista,$i){
	let $lun:=count($lista)
	return for $m in $i to $lun
		return
		if( compare(name($lista[$m]),name($lista[$i]))=0) then
			$lista[$m]
		else
			()
};

declare function local:inizio($lista,$indice){
let $a:=0
return some $b in 1 to (($indice)-1) satisfies (compare(name($lista[$b]),name($lista[$indice]))=0)
};

declare function local:process-element ($element) {	
	if ( (local:has-children($element)) and (name($element) eq $name) )
		then
			local:inizio($element/*)
		else if ( local:has-children($element) )
		then 		
			element { name($element) } {									
				for $attribute in $element/@* 
				return $attribute, 	

				for $child in $element/*
				return local:process-element($child)
			}		
		else		
			element { name($element) } {
				for $attribute in $element/@* return $attribute,data($element)
			}
};


(: Test if an element has children :)
declare function local:has-children ($element) {
	if ( count($element/*) = 0 )
		then false()
		else true()
};

declare function local:inizio($lista){
let $l:=count($lista)
return for $i in 1 to $l
return
	if (not(local:inizio($lista,$i))) then
	element {concat(name($lista[$i]),"s")}
	{local:trova($lista,$i)}
	else
	()
};

let $inutile:=1
return local:process-element(doc($instance)/*)
