(: Funzione che prendendo una lista ordinata la trasforma in disordinata salvando 
per l'ordinamento in un nuovo elemento per ogni elemento appartenente alla lista

Author : Leonardo Puleggi  
Email : leonardo.puleggi@fastwebnet.it
Version : 0.1

Esempio di input
	<b>
		<c><name>luca</name></c>
    <c><name>andrea</name></c>
    <c><name>gianni</name></c>
	</b>

Output
     <c>
         <b-order>1</b-order>
         <name>luca</name>
      </c>
      <c>
         <b-order>2</b-order>
         <name>andrea</name>
      </c>
      <c>
         <b-order>3</b-order>
         <name>gianni</name>
      </c>
:)

declare variable $instance as xs:string external;
declare variable $nome_ord as xs:string external;

declare function local:faiDisorder($instance, $i) {
let $figli := $instance[$i]/*
for $elemento at $k in $figli
	return element {name($elemento)} {for $attributo in $elemento/@* return $attributo,
        if(compare(name($elemento/parent::node()),$nome_ord)=0) then 
        element {concat(name($elemento/parent::node()),"-order")} {$k} 
        else (),
        for $figlio in $elemento/* where empty($figlio/*) return $figlio,
        if (exists($elemento/*/*)) then 
 ( local:faiDisorder($figli, $k) ) else() }
};


let $input:=doc($instance)
let $i:=1
return local:faiDisorder($input, $i)